import sys
import re
import sre
import os.path
def regexp(pattern, string, flags=0):
        if(re.compile(pattern, flags).search(string)==None): return 0
        else: return 1
def regexpn(pattern, string, flags=0):
        r = re.compile(pattern, flags).subn("", string)
        return r[1]
def wsadminToList(inStr):
        outList=[]
        if (len(inStr)>0 and inStr[0]=='[' and inStr[-1]==']'):
                tmpList = inStr[1:-1].split() #splits space-separated lists,
        else:
                tmpList = inStr.split("\n")   #splits for Windows or Linux
        for item in tmpList:
                item = item.rstrip();         #removes any Windows "\r"
                if (len(item)>0):
                        outList.append(item)
        return outList
#endDef
errorCode = ""
errorInfo = ""

#
#  installRRCS.py
#
#  Author: Bala Kolla 09/28/2009
#
#  This script installs the RRCS (Jazz and RDM applications) given server and sets
#  the RRCS documented default settings for JVM and Custom Properties.
#
#  The script is intended to be run command line
#
# In Windows: 
# open the command prompt and cd webspher profile\bin dir: Ex: cd  C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\AppSrv01\bin
# then run the command
# wsadmin -f C:\Program Files (x86)\IBM\RRCS20\server\installRRCS.py  C:/Progra~1/IBM/RRCS20/server server1 hostNameNode01 hostNameNode02
# 
#The script expects the following parameters to be set for a particular environment
#
RRCServerInstallLocation = sys.argv[0]
serverName = sys.argv[1]
nodeName = sys.argv[2]
cellName = sys.argv[3]
if(not os.path.exists(RRCServerInstallLocation)):
    print "ERROR: Server install location provided is not a valid directory."
    print "Execute the command again and specify the valid install location for RRC Server Ex: C:\Progra~1\IBM\RRCS20 or /opt/IBM/RRC20"
    sys.exit(1)
#endIf

#Get the file separator from the OS
fileSeparator = java.lang.System.getProperty("file.separator")

#Check if the path ends with file separator.
if (str(RRCServerInstallLocation).endswith(fileSeparator)):
    RRCServerInstallLocation = RRCServerInstallLocation
else:
    RRCServerInstallLocation = RRCServerInstallLocation + fileSeparator
#endIf

rdm_appcontext_conf = RRCServerInstallLocation+ "server" + fileSeparator + "conf" + fileSeparator + "rdm"
JAZZ_HOME = RRCServerInstallLocation + "server" + fileSeparator + "conf"

if(not os.path.exists(JAZZ_HOME)):
    print "ERROR: Server install location provided is not a valid directory, can't find the path." + JAZZ_HOME
    print "Execute the command again and specify the valid install location for RRC Server Ex: C:\Progra~1\IBM\RRCS20 or /opt/IBM/RRC20"
    sys.exit(1)
else:
    if str(JAZZ_HOME).startswith(fileSeparator):
       JAZZ_HOME = "file://" + JAZZ_HOME
    else:
       JAZZ_HOME = "file:///" + JAZZ_HOME
    #endIf
#endIf

if(not os.path.exists(rdm_appcontext_conf)):
    print "ERROR: Server install location provided is not a valid directory, can't find the path." + rdm_appcontext_conf
    print "Execute the command again and specify the valid install location for RRC Server Ex: C:\Progra~1\IBM\RRCS20 or /opt/IBM/RRC20"
    sys.exit(1)
else:
    #for Linux/Unix path might start with / and causing provisioning issues.
    if str(rdm_appcontext_conf).startswith(fileSeparator):
        rdm_appcontext_conf = "file://"+ rdm_appcontext_conf
    else:
        rdm_appcontext_conf = "file:///"+ rdm_appcontext_conf
    #endIf
#endIf

#--------------------------------------------------------------
# Do not change the following variables for the default installation
#--------------------------------------------------------------
virtualHost = "default_host"

MaximumHeapSize = "1536"
javaawtheadless = "true"
doNotLoadResourcesPlugin = "true"

#--------------------------------------------------------------
# set up globals
#--------------------------------------------------------------
global AdminApp
global AdminControl
global AdminConfig
global Help

#--------------------------------------------------------------
# Check for available node
#--------------------------------------------------------------
print "--------------------------------------------------------------"
print "Checking for existence of node "+nodeName
node = AdminConfig.getid("/Node:"+nodeName+"/" )
if (len(node) == 0):
        print "Error -- node not found for name " + nodeName
        exit 
#endIf 
print " "
print "Node "+nodeName+" found"

#--------------------------------------------------------------
# Check if application is installed
#--------------------------------------------------------------
print "--------------------------------------------------------------"

lineSeparator = java.lang.System.getProperty("line.separator")
appFound = "false"

def getConfirmation(confirmMessage):
    userIn = raw_input(confirmMessage)
    if(len(userIn)== 0 or (userIn.lower() != "yes" and userIn.lower() !="no")):
        print "-- You must enter Yes or No: "
        return getConfirmation(confirmMessage)
    #endIf
    return userIn.lower()
#endDef

def unInstallApp(appName,jfsApp):
        global serverName
        global nodeName
        global cellName
        global lineSeparator
        global appFound
        appFound = "false"
        
        print "--------------------------------------------------------------"
        print "Checking if application is already installed"
        print ""
        apps = AdminApp.list()
        if len(apps) == 0:
            print "  There are no applications installed on " + serverName
        else:
            appsList = apps.split(lineSeparator)
            print "  Number of applications running on %s: %s" % (serverName, len(appsList))
        #endIf
        
        for app in appsList:
            aname = app
            print "    %s" % (aname)
            if appName == aname:
                appFound = "true"
            #endIf
        #endFor
        
        if appFound == "true":
            print "--------------------------------------------------------------"
            print ""
           #--------------------------------------------------------------
           # Stop the application if it is installed
           #--------------------------------------------------------------
           #Prompt for the confirmation that the application will be stopped
            print "application '" + appName + "' found, and it should be stopped before uninstalling application. "
            
            if(jfsApp == "True"):
                print ""
                print "Make sure that the application '" + appName + "' is part of RRC install and not installed by any other Jazz based product (Ex: RTC, RQM...) "
            #endIf
            
            print " "
            userIn = getConfirmation("Type Yes to stop the application '" + appName + "'or No to exit the script(and press Enter):")
            if(userIn == "no"):
                print ""
                print "Exiting the script as the user decided to NOT proceed with stopping the existing application: '" + appName + "'"
                sys.exit(1)
            #endIf    
            print "--------------------------------------------------------------"
            print ""
            print "Stopping the application: '" + appName + "'"
            query = "cell="+cellName+",node="+nodeName+",type=ApplicationManager,"
            query += "process="+serverName+",*"
            appManager = AdminControl.queryNames(query )
            try:
                _excp_ = 0
                stopAppResult = AdminControl.invoke(appManager, 'stopApplication', appName)
                _excp_ = 0 #reset (in case of nested exceptions)
            except:
                    _type_, _value_, _tbck_ = sys.exc_info()
                    stopAppResult = str(_value_)
                    _excp_ = 1
            #endTry 
                    
            if (_excp_ ):
                    # Exception is thrown don't do any thing
                    print "Exception stopping application. This may be due to the application already being stopped. "+stopAppResult
            #endIf 
            
            print "--------------------------------------------------------------"
            print ""
            #--------------------------------------------------------------
            # Uninstall the current application if it is installed
            #--------------------------------------------------------------
            #Prompt for the confirmation that the application will be stopped
            print "application '" + appName + "' should be uninstalled before installing the new application. "
            
            if(jfsApp == "True"):
                print ""
                print "Make sure that the application '" + appName + "' is part of RRC install and not installed by any other Jazz based product (Ex: RTC, RQM...) "
            #endIf
            
            print " "
            userIn = getConfirmation("Type Yes to proceed with uninstallig the application '" + appName + "' or No to exit the script (and press Enter):")
            if(userIn == "no"):
                print ""
                print "Exiting the script as the user decided to NOT proceed with uninstalling the existing application:'" + appName + "'"
                sys.exit(1)
            #endIf
            print " "
            print "Uninstalling the application: '" + appName + "'"
            AdminApp.uninstall(appName )
            print " "
            print "Uninstall of application '" + appName + "' completed"
            AdminConfig.save( )
            print "Save configuration completed"
       #endIf 
    #endElse
#endDef

def installApp(warFile, appName, contextRoot, displayName):
    global lineSeparator
    global serverName
    global nodeName
    global cellName
    global virtualHost
    #--------------------------------------------------------------
    # Install and start the Jazz application
    #--------------------------------------------------------------
    print "--------------------------------------------------------------"
    print " "
    print "Begin installation of application"
    
    serv = "WebSphere:cell="+cellName+",node="+nodeName+",server="+serverName
    
    defapp = RRCServerInstallLocation + "server" + fileSeparator +warFile
    if(not os.path.exists(defapp)):
    	defapp = RRCServerInstallLocation + "server" + fileSeparator + "tomcat" + fileSeparator + "webapps" + fileSeparator +warFile
    #endIf
    
    print "Use the server: "+serv
    print "WAR file to be deployed: "+defapp
    print "Application Name: "+appName
    print "WAS ServerName: "+serverName
    print "WAS NodeName: "+nodeName
    print "WAS cellName: "+cellName
    print "Application virtualHost: "+virtualHost
    print "Application contextroot "+contextRoot
    
    appopts = "[-appname "
    appopts = appopts + appName + " -server " + serverName + " -node " + nodeName + " -contextroot " + contextRoot
    
    mapping = "[" + displayName + " " + warFile + ",WEB-INF/web.xml " + virtualHost + "]"
    mapVHopt = " -MapWebModToVH [" + mapping + "]"
    appopts = appopts + mapVHopt
    
    miscopts = " -nopreCompileJSPs -distributeApp -nouseMetaDataFromBinary -nodeployejb -createMBeansForResources -noreloadEnabled -nodeployws -validateinstall warn -noprocessEmbeddedConfig]"
    appopts = appopts + miscopts
    
    print appopts
    
    AdminApp.install(defapp, appopts )
    print " "
    print "Install of '" + appName + "' completed"
    
    #--------------------------------------------------------------
    # Save RRC Server install application changes 
    #--------------------------------------------------------------
    print "--------------------------------------------------------------"
    print "Save install application changes"
    
    AdminConfig.save( )
    print " "
    print "Save "+appName+" install changes completed"
    
    #--------------------------------------------------------------
    # Start application 
    #--------------------------------------------------------------
    print "--------------------------------------------------------------"
    print "Start application"
    
    if(AdminApp.isAppReady(appName)):
        try:
            _excp_ = 0
            appManager = AdminControl.queryNames("cell="+cellName+",node="+nodeName+",type=ApplicationManager,process="+serverName+",*" )
            startAppResult = AdminControl.invoke(appManager, "startApplication", appName )
            _excp_ = 0 #reset (in case of nested exceptions)
        except:
            _type_, _value_, _tbck_ = sys.exc_info()
            startAppResult = str(_value_)
            _excp_ = 1
        #endTry 
            
        if (_excp_ ):
                # Exception is thrown don't do any thing
                print "Exception starting application. Try restarting the application server: "+startAppResult
        #endIf
    #endIf
    print " "
    print appName+" application started"
#endDef

def getAppName(warFile,defAppName):
    appName = raw_input("Enter the application name for '" + warFile + "' Or press Enter to use the default name '" + defAppName + "':")
    if(len(appName)==0):
        print " Default application name '" + defAppName + "' will be used:"
        return defAppName
    #endIf
    return appName
#endDef

def getAppContextRootForJazz(appName,defAppContextRoot):
    print "--------------------------------------------------------------"
    print " "
    appContext = raw_input("Enter the context root for application '" + appName + "' Or press Enter to use the default context root '" + defAppContextRoot + "':")
    if(len(appContext)==0):
        print appContext+" Default application context '" + defAppContextRoot + "' will be used:"
        return defAppContextRoot
    #endIf
    return appContext
#endDef

fileName_jazz = "jazz.war"
appName_jazz = "jazz_war"
displayName_jazz = "jazz.war"
contextRoot_jazz = "/jazz"
#Prompt for the jazz application name
appName_jazz = getAppName (fileName_jazz,appName_jazz)
unInstallApp(appName_jazz,"True")
#Prompt for the context root for jazz application
contextRoot_jazz = getAppContextRootForJazz(appName_jazz,contextRoot_jazz)
installApp(fileName_jazz, appName_jazz, contextRoot_jazz, displayName_jazz)

fileName_rdm = "rdm.war"
appName_rdm = "rdm_war"
displayName_rdm = "rdm.war"
contextRoot_rdm = "/rdm"
unInstallApp(appName_rdm,"False")
installApp(fileName_rdm, appName_rdm, contextRoot_rdm, displayName_rdm)

fileName_converter = "converter.war"
appName_converter = "converter_war"
displayName_converter = "converter.war"
contextRoot_converter = "/converter"
unInstallApp(appName_converter,"False")
installApp(fileName_converter, appName_converter, contextRoot_converter, displayName_converter)

fileName_rrc_help = "rrc-help.war"
appName_rrc_help = "rrc-help_war"
displayName_rrc_help = "rrc-help.war"
contextRoot_rrc_help = "/rrc-help"
unInstallApp(appName_rrc_help,"False")
installApp(fileName_rrc_help, appName_rrc_help, contextRoot_rrc_help, displayName_rrc_help)

#--------------------------------------------------------------
#  modify maximumHeapSize in JavaVirtualMachine 
#--------------------------------------------------------------

print "--------------------------------------------------------------"
print "Modify JVM maximumHeapSize"

server = AdminConfig.getid("/Server:" + serverName + "/")
JavaVirtualMachineId = AdminConfig.list('JavaVirtualMachine',server)

print JavaVirtualMachineId

#------------- modify maximumHeapSize -------------------------
FlagNoChangeNeccessary = "false"
attrs = [["maximumHeapSize", MaximumHeapSize]]
TmpMaximumHeapSize = AdminConfig.showAttribute(JavaVirtualMachineId, "maximumHeapSize" )
print "Old: JVM maximumHeapSize = "+TmpMaximumHeapSize
if (cmp(TmpMaximumHeapSize, MaximumHeapSize) != 0):
        AdminConfig.modify(JavaVirtualMachineId, attrs )
else:
        print " "
        print "Value is OK, no action taken"
        FlagNoChangeNeccessary = "true"
#endElse 

#------------- check for success -----------------------------
if (FlagNoChangeNeccessary == "false"):
        TmpMaximumHeapSize = AdminConfig.showAttribute(JavaVirtualMachineId, "maximumHeapSize" )
        print "New: JVM maximumHeapSize = "+TmpMaximumHeapSize
        if (cmp(TmpMaximumHeapSize, MaximumHeapSize) != 0):
                print "ERROR: JVM Property could not be modified."
                sys.exit(1)
        else:
                print " "
                print "JVM Property succesfull modified."
                AdminConfig.save( )
        #endElse 
#endIf 

#-------------------------------------------------------------
#                set JVM Custom Properties 
#-------------------------------------------------------------
print "--------------------------------------------------------------"
print "Beginning modification of JVM Custom Properties"

def addCutomProp(customPropName, customPropVal):
    n1 = ["name", customPropName]
    v1 = ["value", customPropVal]
    propAttr = [n1, v1]
    
    exismod = AdminConfig.getid("/Property:"+customPropName +"/" )
    customPropFound = "True"
    insClusName = ""
    if (exismod != None and exismod != ""):
        print "custom property " + customPropName + "Found:" + exismod
        insClusName=AdminConfig.showAttribute(exismod, 'name')
    else:
        customPropFound = "False"
    #endIf
    
    if (customPropFound == "True" and regexp(customPropName, insClusName) == 1):
            exismodVal =AdminConfig.showAttribute(exismod, 'value')
            print "Existing "+customPropName +" property found.\"" + exismodVal + "\""
            if (regexp(customPropVal, exismodVal) == 0):
                AdminConfig.modify(exismod, propAttr)
                print "Replaced existing settings for \""+customPropName +"\" with specified values \"" + customPropVal + "\""
            else:
                print "Existing "+customPropName +" property is in sync. No need to replace..." + exismodVal
    else:
            print "custom property " + customPropName + "Not Found, trying to create"
            AdminConfig.create("Property", JavaVirtualMachineId, propAttr )
            print "Added specified \""+customPropName +"\" Custom Properties successfully"
    #endElse 
    
    AdminConfig.save()
#endDef

#-------------- Set JAZZ_HOME custom property -------------
print "    "
print "--------------Set JAZZ_HOME custom property-------------"
addCutomProp("JAZZ_HOME",JAZZ_HOME)

#-------------- Set JAZZ_HOME custom property -------------
print "    "
print "--------------Set com.ibm.team.jfs.app.context.conf custom property-------------"
addCutomProp("com.ibm.team.jfs.app.context.conf",rdm_appcontext_conf)

#-------------- Set com.ibm.team.jfs.app.servlet.useGzip custom property -------------
print "    "
print "--------------Set com.ibm.team.jfs.app.servlet.useGzip custom property-------------"
addCutomProp("com.ibm.team.jfs.app.servlet.useGzip","true")

#-------------- Set com.ibm.team.jfs.app.transport.useDispatch custom property -------------
print "    "
print "--------------Set com.ibm.team.jfs.app.transport.useDispatch custom property-------------"
addCutomProp("com.ibm.team.jfs.app.transport.useDispatch","false")

#-------------- Set java.awt.headless custom property -------------
print "    "
print "--------------Set java.awt.headless custom property-------------"
addCutomProp("java.awt.headless",javaawtheadless)

#-------------- Set org.eclipse.emf.ecore.plugin.EcorePlugin.doNotLoadResourcesPlugin custom property -------------
print "    "
print "--------------Set org.eclipse.emf.ecore.plugin.EcorePlugin.doNotLoadResourcesPlugin  custom property-------------"
addCutomProp("org.eclipse.emf.ecore.plugin.EcorePlugin.doNotLoadResourcesPlugin",doNotLoadResourcesPlugin)

print " "
print "Install JVM Custom Properties completed"
print "--------------------------------------------------------------"
print " "
print "Install completed"
print "You may need to restart your WAS Server."

